ARCHITECTURE RTL OF stepperMotorPrescaler IS

  signal testPrescalerCounter: unsigned(testPrescalerbitNb-1 downto 0);
  signal testPrescalerDone: std_ulogic;

  signal prescalerCounter: unsigned(prescaler'range);
  signal prescalerDone: std_ulogic;

BEGIN
  ------------------------------------------------------------------------------
                                                  -- test mode presacler counter
  testDivide: process(reset, clock)
  begin
    if reset = '1' then
      testPrescalerCounter <= (others => '0');
    elsif rising_edge(clock) then
      testPrescalerCounter <= testPrescalerCounter + 1;
    end if;
  end process testDivide;

  testPrescalerDone <= '1' when testMode = '0'
    else '1' when testPrescalerCounter = 0
    else '0';

  ------------------------------------------------------------------------------
                                                            -- presacler counter
  prescalerDivide: process(reset, clock)
  begin
    if reset = '1' then
      prescalerCounter <= (others => '0');
    elsif rising_edge(clock) then
      if testPrescalerDone = '1' then
        if prescalerDone = '1' then
          prescalerCounter <= (others => '0');
        else
          prescalerCounter <= prescalerCounter + 1;
        end if;
      end if;
    end if;
  end process prescalerDivide;

  prescalerDone <= testPrescalerDone when prescalerCounter+1 >= prescaler
    else '0';
  pwmEn <= prescalerDone;

END ARCHITECTURE RTL;
